package com.temboo.outputs.Dropbox;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  The user's quota info for shared/unshared folders
  
*/
public class DropboxQuotaInfo {
    protected JSONObject base;
    
    public DropboxQuotaInfo(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The user's used quota outside of shared folders (bytes).
    */
    public Number getNormal() {
        return (Number) base.opt("normal");
    }

    /** The user's used quota in shared folders (bytes).
    */
    public Number getQuota() {
        return (Number) base.opt("quota");
    }

    /** The user's total quota allocation (bytes).
    */
    public Number getShared() {
        return (Number) base.opt("shared");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}