package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Facebook.FacebookSchool;
import com.temboo.outputs.Facebook.FacebookYear;

/**  An entry from a user's education history
  
*/
public class FacebookEducation {
    protected JSONObject base;
    
    public FacebookEducation(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** Get the school for this user
    */
    public FacebookSchool getSchool() {
        return new FacebookSchool(base.opt("school"));
    }

    /** The type of school
    */
    public String getType() {
        return (String) base.opt("type");
    }

    /** Get the graduation year info for a user's school
    */
    public FacebookYear getYear() {
        return new FacebookYear(base.opt("year"));
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}