package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing format parameters for the video

*/
public class FacebookFormat {
    protected JSONObject base;
    
    public FacebookFormat(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The html element that may be embedded in an Web page to play the video
    */
    public String getEmbedHtml() {
        return (String) base.opt("embed_html");
    }

    /** The video filter parameter
    */
    public String getFilter() {
        return (String) base.opt("filter");
    }

    /** The video height
    */
    public Number getHeight() {
        return (Number) base.opt("height");
    }

    /** The URL for the thumbnail picture for the video
    */
    public String getPicture() {
        return (String) base.opt("picture");
    }

    /** The video width
    */
    public Number getWidth() {
        return (Number) base.opt("width");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}