package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing information for the groups that the authenticated user belongs to

*/
public class FacebookGroup {
    protected JSONObject base;
    
    public FacebookGroup(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** Whether or not the authenticated user is the adminstrator of the group
    */
    public Boolean getAdministrator() {
        return (Boolean) base.opt("administrator");
    }

    /** The bookmark order for the group
    */
    public Number getBookmarkOrder() {
        return (Number) base.opt("bookmark_order");
    }

    /** The group id
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The group name
    */
    public String getName() {
        return (String) base.opt("name");
    }

    /** The group version
    */
    public Number getVersion() {
        return (Number) base.opt("version");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}