package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing location information for the place
  
*/
public class FacebookLocation {
    protected JSONObject base;
    
    public FacebookLocation(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The city that the place is located in
    */
    public String getCity() {
        return (String) base.opt("city");
    }

    /** The country that the place is located in
    */
    public String getCountry() {
        return (String) base.opt("country");
    }

    /** The latitude coordinate
    */
    public Number getLatitude() {
        return (Number) base.opt("latitude");
    }

    /** The longitude coordinate
    */
    public Number getLongitude() {
        return (Number) base.opt("longitude");
    }

    /** The state abbreviation for the place
    */
    public String getState() {
        return (String) base.opt("state");
    }

    /** The street address for the place
    */
    public String getStreet() {
        return (String) base.opt("street");
    }

    /** The zip code for the place
    */
    public String getZip() {
        return (String) base.opt("zip");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}