package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Facebook.FacebookFrom;

/**  An object containing information about the authenticated user's note

*/
public class FacebookNote {
    protected JSONObject base;
    
    public FacebookNote(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The date and time the note was created
    */
    public String getCreatedTime() {
        return (String) base.opt("created_time");
    }

    /** Get the user that the note is from
    */
    public FacebookFrom getFrom() {
        return new FacebookFrom(base.opt("from"));
    }

    /** The icon for the note
    */
    public String getIcon() {
        return (String) base.opt("icon");
    }

    /** The id of the note
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The message
    */
    public String getMessage() {
        return (String) base.opt("message");
    }

    /** The subject of the note
    */
    public String getSubject() {
        return (String) base.opt("subject");
    }

    /** The last updated time of the note
    */
    public String getUpdatedTime() {
        return (String) base.opt("updated_time");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}