package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  A permission (or scope) associated with the access token used in the request

*/
public class FacebookPermission {
    protected JSONObject base;
    
    public FacebookPermission(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** Provides the ability to manage ads and call the Facebook Ads API on behalf of a user
    */
    public Number getAdsManagement() {
        return (Number) base.opt("ads_management");
    }

    /** Enables your application to create and modify events on the user's behalf
    */
    public Number getCreateEvent() {
        return (Number) base.opt("create_event");
    }

    /** Enables your application to create notes on the user's behalf
    */
    public Number getCreateNote() {
        return (Number) base.opt("create_note");
    }

    /** Provides access to the user's primary email address in the email property.
    */
    public Number getEmail() {
        return (Number) base.opt("email");
    }

    /** Provides access to the user's friend's about me info
    */
    public Number getFriendsAboutMe() {
        return (Number) base.opt("friends_about_me");
    }

    /** Provides access to the user's friend's activities
    */
    public Number getFriendsActivities() {
        return (Number) base.opt("friends_activities");
    }

    /** Provides access to the user's friend's birthdays
    */
    public Number getFriendsBirthday() {
        return (Number) base.opt("friends_birthday");
    }

    /** Provides access to the user's friend's education history
    */
    public Number getFriendsEducationHistory() {
        return (Number) base.opt("friends_education_history");
    }

    /** Provides access to the user's friend's events
    */
    public Number getFriendsEvents() {
        return (Number) base.opt("friends_events");
    }

    /** Provides access to the user's friend's game activities
    */
    public Number getFriendsGamesActivity() {
        return (Number) base.opt("friends_games_activity");
    }

    /** Provides access to the user's friend's groups
    */
    public Number getFriendsGroups() {
        return (Number) base.opt("friends_groups");
    }

    /** Provides access to the user's friend's hometown info
    */
    public Number getFriendsHometown() {
        return (Number) base.opt("friends_hometown");
    }

    /** Provides access to the user's friend's interests
    */
    public Number getFriendsInterests() {
        return (Number) base.opt("friends_interests");
    }

    /** Provides access to the user's friend's likes
    */
    public Number getFriendsLikes() {
        return (Number) base.opt("friends_likes");
    }

    /** Provides access to the user's friend's location info
    */
    public Number getFriendsLocation() {
        return (Number) base.opt("friends_location");
    }

    /** Provides access to the user's friend's notes
    */
    public Number getFriendsNotes() {
        return (Number) base.opt("friends_notes");
    }

    /** Provides access to the user's friend's online/offline presence
    */
    public Number getFriendsOnlinePresence() {
        return (Number) base.opt("friends_online_presence");
    }

    /** Provides access to the user's friend's video tags
    */
    public Number getFriendsPhotoVideoTags() {
        return (Number) base.opt("friends_photo_video_tags");
    }

    /** Provides access to the user's friend's photos
    */
    public Number getFriendsPhotos() {
        return (Number) base.opt("friends_photos");
    }

    /** Provides access to the user's friend's questions
    */
    public Number getFriendsQuestions() {
        return (Number) base.opt("friends_questions");
    }

    /** Provides access to the user's friend's relationship details
    */
    public Number getFriendsRelationshipDetails() {
        return (Number) base.opt("friends_relationship_details");
    }

    /** Provides access to the user's friend's relationship
    */
    public Number getFriendsRelationships() {
        return (Number) base.opt("friends_relationships");
    }

    /** Provides access to the user's friend's religion and politics affiliations
    */
    public Number getFriendsReligionPolitics() {
        return (Number) base.opt("friends_religion_politics");
    }

    /** Provides access to the user's friend's status
    */
    public Number getFriendsStatus() {
        return (Number) base.opt("friends_status");
    }

    /** Provides access to the user's friend's subscriptions
    */
    public Number getFriendsSubscriptions() {
        return (Number) base.opt("friends_subscriptions");
    }

    /** Provides access to the user's friend's videos
    */
    public Number getFriendsVideos() {
        return (Number) base.opt("friends_videos");
    }

    /** Provides access to the user's friend's website
    */
    public Number getFriendsWebsite() {
        return (Number) base.opt("friends_website");
    }

    /** Provides access to the user's friend's work history
    */
    public Number getFriendsWorkHistory() {
        return (Number) base.opt("friends_work_history");
    }

    /** Enables your app to create and edit the user's friend lists
    */
    public Number getManageFriendlists() {
        return (Number) base.opt("manage_friendlists");
    }

    /** Enables your app to read notifications and mark them as read
    */
    public Number getManageNotifications() {
        return (Number) base.opt("manage_notifications");
    }

    /** Enables your application to retrieve access_tokens for Pages and Applications that the user administrates
    */
    public Number getManagePages() {
        return (Number) base.opt("manage_pages");
    }

    /** Enables your application to upload photos for a user
    */
    public Number getPhotoUpload() {
        return (Number) base.opt("photo_upload");
    }

    /** Allows your app to publish to the Open Graph
    */
    public Number getPublishActions() {
        return (Number) base.opt("publish_actions");
    }

    /** Enables your app to perform checkins on behalf of the user
    */
    public Number getPublishCheckins() {
        return (Number) base.opt("publish_checkins");
    }

    /** Enables your app to post content, comments, and likes to a user's stream and to the streams of the user's friends
    */
    public Number getPublishStream() {
        return (Number) base.opt("publish_stream");
    }

    /** Provides access to any friend lists the user created
    */
    public Number getReadFriendlists() {
        return (Number) base.opt("read_friendlists");
    }

    /** Provides read access to the Insights data for pages, applications, and domains the user owns
    */
    public Number getReadInsights() {
        return (Number) base.opt("read_insights");
    }

    /** Provides the ability to read from a user's Facebook Inbox
    */
    public Number getReadMailbox() {
        return (Number) base.opt("read_mailbox");
    }

    /** Provides read access to the user's friend requests
    */
    public Number getReadRequests() {
        return (Number) base.opt("read_requests");
    }

    /** Provides access to all the posts in the user's News Feed and enables your application to perform searches against the user's News Feed
    */
    public Number getReadStream() {
        return (Number) base.opt("read_stream");
    }

    /** Enables your application to RSVP to events on the user's behalf
    */
    public Number getRsvpEvent() {
        return (Number) base.opt("rsvp_event");
    }

    /** Enables your application to update a user's status
    */
    public Number getStatusUpdate() {
        return (Number) base.opt("status_update");
    }

    /** Provides access to the "About Me" section of the profile in the about property
    */
    public Number getUserAboutMe() {
        return (Number) base.opt("user_about_me");
    }

    /** Allows you to retrieve the actions published by all applications using the built-in music.listens action
    */
    public Number getUserActionsMusic() {
        return (Number) base.opt("user_actions.music");
    }

    /** Allows you to retrieve the actions published by all applications using the built-in news.reads action
    */
    public Number getUserActionsNews() {
        return (Number) base.opt("user_actions.news");
    }

    /** Allows you to retrieve the actions published by all applications using the built-in video.watches action
    */
    public Number getUserActionsVideo() {
        return (Number) base.opt("user_actions.video");
    }

    /** Provides access to the user's list of activities as the activities connection
    */
    public Number getUserActivities() {
        return (Number) base.opt("user_activities");
    }

    /** Provides access to the birthday with year as the birthday property
    */
    public Number getUserBirthday() {
        return (Number) base.opt("user_birthday");
    }

    /** Provides read access to the authorized user's check-ins or a friend's check-ins that the user can see
    */
    public Number getUserCheckins() {
        return (Number) base.opt("user_checkins");
    }

    /** Provides access to education history as the education property
    */
    public Number getUserEducationHistory() {
        return (Number) base.opt("user_education_history");
    }

    /** Provides access to the list of events the user is attending as the events connection
    */
    public Number getUserEvents() {
        return (Number) base.opt("user_events");
    }

    /** Allows you post and retrieve game achievement activity
    */
    public Number getUserGamesActivity() {
        return (Number) base.opt("user_games_activity");
    }

    /** Provides access to the list of groups the user is a member of as the groups connection
    */
    public Number getUserGroups() {
        return (Number) base.opt("user_groups");
    }

    /** Provides access to the user's hometown in the hometown property
    */
    public Number getUserHometown() {
        return (Number) base.opt("user_hometown");
    }

    /** Provides access to the user's list of interests as the interests connection
    */
    public Number getUserInterests() {
        return (Number) base.opt("user_interests");
    }

    /** Provides access to the list of all of the pages the user has liked as the likes connection
    */
    public Number getUserLikes() {
        return (Number) base.opt("user_likes");
    }

    /** Provides access to the user's current city as the location property
    */
    public Number getUserLocation() {
        return (Number) base.opt("user_location");
    }

    /** Provides access to the user's notes as the notes connection
    */
    public Number getUserNotes() {
        return (Number) base.opt("user_notes");
    }

    /** Provides access to the user's online/offline presence
    */
    public Number getUserOnlinePresence() {
        return (Number) base.opt("user_online_presence");
    }

    /** Provides access to video tags
    */
    public Number getUserPhotoVideoTags() {
        return (Number) base.opt("user_photo_video_tags");
    }

    /** Provides access to the photos the user has uploaded, and photos the user has been tagged in
    */
    public Number getUserPhotos() {
        return (Number) base.opt("user_photos");
    }

    /** Provides access to the questions the user or friend has asked
    */
    public Number getUserQuestions() {
        return (Number) base.opt("user_questions");
    }

    /** Provides access to the user's relationship preferences
    */
    public Number getUserRelationshipDetails() {
        return (Number) base.opt("user_relationship_details");
    }

    /** Provides access to the user's family and personal relationships and relationship status
    */
    public Number getUserRelationships() {
        return (Number) base.opt("user_relationships");
    }

    /** Provides access to the user's religious and political affiliations
    */
    public Number getUserReligionPolitics() {
        return (Number) base.opt("user_religion_politics");
    }

    /** Provides access to the user's status messages and checkins
    */
    public Number getUserStatus() {
        return (Number) base.opt("user_status");
    }

    /** Provides access to the user's subscribers and subscribees
    */
    public Number getUserSubscriptions() {
        return (Number) base.opt("user_subscriptions");
    }

    /** Provides access to the videos the user has uploaded, and videos the user has been tagged in
    */
    public Number getUserVideos() {
        return (Number) base.opt("user_videos");
    }

    /** Provides access to the user's web site URL
    */
    public Number getUserWebsite() {
        return (Number) base.opt("user_website");
    }

    /** Provides access to work history as the work property
    */
    public Number getUserWorkHistory() {
        return (Number) base.opt("user_work_history");
    }

    /** Provides access to upload videos
    */
    public Number getVideoUpload() {
        return (Number) base.opt("video_upload");
    }

    /** 
    */
    public Number getWhitelistedOfflineAccess() {
        return (Number) base.opt("whitelisted_offline_access");
    }

    /** Provides applications that integrate with Facebook Chat the ability to log in users
    */
    public Number getXmppLogin() {
        return (Number) base.opt("xmpp_login");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}