package com.temboo.outputs.Facebook;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing the privacy settings of the graph object

*/
public class FacebookPrivacy {
    protected JSONObject base;
    
    public FacebookPrivacy(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The allow field for the privacy setting
    */
    public String getAllow() {
        return (String) base.opt("allow");
    }

    /** The deny field for the privacy setting
    */
    public String getDeny() {
        return (String) base.opt("deny");
    }

    /** The description field for the privacy setting
    */
    public String getDescription() {
        return (String) base.opt("description");
    }

    /** The friends field for the privacy setting
    */
    public String getFriends() {
        return (String) base.opt("friends");
    }

    /** The networks field for the privacy setting
    */
    public String getNetworks() {
        return (String) base.opt("networks");
    }

    /** The value field for the privacy setting
    */
    public String getValue() {
        return (String) base.opt("value");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}