package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquareBadgeImage;

/**  Contains badges associated with the checkin

*/
public class FoursquareBadge {
    protected JSONObject base;
    
    public FoursquareBadge(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** A canonical ID for this badge
    */
    public String getBadgeId() {
        return (String) base.opt("badgeId");
    }

    /** The badge description
    */
    public String getDescription() {
        return (String) base.opt("description");
    }

    /** A unique identifier for this badge
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** Get the badge image information
    */
    public FoursquareBadgeImage getBadgeImage() {
        return new FoursquareBadgeImage(base.opt("image"));
    }

    /** The name of the badge
    */
    public String getName() {
        return (String) base.opt("name");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}