package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing twitter, phone, and formattedPhone of the user or venue contact. All can be present, and all can be absent from the response.

*/
public class FoursquareContact {
    protected JSONObject base;
    
    public FoursquareContact(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The email address of the contact
    */
    public String getEmail() {
        return (String) base.opt("email");
    }

    /** The facebook id of the contact
    */
    public String getFacebook() {
        return (String) base.opt("facebook");
    }

    /** The formatted phone number of the contact
    */
    public String getFormattedPhone() {
        return (String) base.opt("formattedPhone");
    }

    /** The unformatted phone number of the contact
    */
    public String getPhone() {
        return (String) base.opt("phone");
    }

    /** The twitter handle of the contact
    */
    public String getTwitter() {
        return (String) base.opt("twitter");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}