package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquareUser;

/** 
    
*/
public class FoursquareHereNowItem {
    protected JSONObject base;
    
    public FoursquareHereNowItem(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** When the checkin was created in epoch format
    */
    public Number getCreatedAt() {
        return (Number) base.opt("createdAt");
    }

    /** The id of the checkin
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** Whether or not this checkin is from the mayor
    */
    public Boolean getIsMayor() {
        return (Boolean) base.opt("isMayor");
    }

    /** The timezone associated with the checkin
    */
    public String getTimeZone() {
        return (String) base.opt("timeZone");
    }

    /** The timezone offset associated with the checkin
    */
    public Number getTimeZoneOffset() {
        return (Number) base.opt("timeZoneOffset");
    }

    /** The type of checkin
    */
    public String getType() {
        return (String) base.opt("type");
    }

    /** Get the user details
    */
    public FoursquareUser getUser() {
        return new FoursquareUser(base.opt("user"));
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}