package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/** 
        
*/
public class FoursquareImage {
    protected JSONObject base;
    
    public FoursquareImage(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The name of the image used to contruct the complete image url
    */
    public String getName() {
        return (String) base.opt("name");
    }

    /** The beginning portion of the image url used to contruct the complete image url
    */
    public String getPrefix() {
        return (String) base.opt("prefix");
    }

    /** The available image sizes used to construct the complete image url
    */
    public Number[] getSizes() {
        JSONArray list = (JSONArray) base.opt("sizes");
        Number[] resultArray = new Number[(list != null) ? list.length() : 0];
        if(list != null) {
        	for(int i=0; i<list.length(); i++) {
        	    try {
        	        resultArray[i] = (Number) list.get(i);
        	    } catch (JSONException e) {}
        	}
        }
        return resultArray;

    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}