package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquarePoints;

/**  Contains information about insights related to this checkin
    
*/
public class FoursquareInsight {
    protected JSONObject base;
    
    public FoursquareInsight(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The url for the appropriate foursquare icon
    */
    public String getImage() {
        return (String) base.opt("image");
    }

    /** Get the points information for the insight
    */
    public FoursquarePoints getPoints() {
        return new FoursquarePoints(base.opt("points"));
    }

    /** The title of the insight
    */
    public String getTitle() {
        return (String) base.opt("title");
    }

    /** The type of insight
    */
    public String getType() {
        return (String) base.opt("type");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}