package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  Cotains leaderboard scores for the authenticated user
      
*/
public class FoursquareLeaderboardScores {
    protected JSONObject base;
    
    public FoursquareLeaderboardScores(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The user's total checkin count over the past 7 days
    */
    public Number getCheckinsCount() {
        return (Number) base.opt("checkinsCount");
    }

    /** If the user has never scored more than a certain number of points, then this field is returned (current value is 50)
    */
    public Number getGoal() {
        return (Number) base.opt("goal");
    }

    /** The highest 7-day score the user has ever achieved
    */
    public Number getMax() {
        return (Number) base.opt("max");
    }

    /** The user's total score over the past 7 days
    */
    public Number getRecent() {
        return (Number) base.opt("recent");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}