package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquareTipsCount;

/**  Contains the followers of the list
  
*/
public class FoursquareListFollower {
    protected JSONObject base;
    
    public FoursquareListFollower(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The canonical URL for the user following the list
    */
    public String getCanonicalUrl() {
        return (String) base.opt("canonicalUrl");
    }

    /** The first name of the user following the list
    */
    public String getFirstName() {
        return (String) base.opt("firstName");
    }

    /** The gender of the user who is following the list
    */
    public String getGender() {
        return (String) base.opt("gender");
    }

    /** The home city of the user who is following the list
    */
    public String getHomeCity() {
        return (String) base.opt("homeCity");
    }

    /** The id of the user who is following the list
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The last name of the user who is following the list
    */
    public String getLastName() {
        return (String) base.opt("lastName");
    }

    /** The url to the photo of the follower
    */
    public String getPhoto() {
        return (String) base.opt("photo");
    }

    public FoursquareTipsCount getTipsCount() {
        return new FoursquareTipsCount(base.opt("tips"));
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}