package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquareUser;

/**  Contains information about overlapping checkins
  
*/
public class FoursquareOverlap {
    protected JSONObject base;
    
    public FoursquareOverlap(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The epoch timestamp for the overlapping checkin
    */
    public Number getCreatedAt() {
        return (Number) base.opt("createdAt");
    }

    /** The id of the overlapping ehckin
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The timezone for the overlapping checkin
    */
    public String getTimeZone() {
        return (String) base.opt("timeZone");
    }

    /** The timezone offset for the checkin
    */
    public Number getTimeZoneOffset() {
        return (Number) base.opt("timeZoneOffset");
    }

    /** The type of foursquare object
    */
    public String getType() {
        return (String) base.opt("type");
    }

    /** Get the users overlapping with the checkin
    */
    public FoursquareUser getUser() {
        return new FoursquareUser(base.opt("user"));
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}