package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing the source information about this object

*/
public class FoursquareSource {
    protected JSONObject base;
    
    public FoursquareSource(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The detail url for the application that created the object
    */
    public String getDetailUrl() {
        return (String) base.opt("detailUrl");
    }

    /** The icon for the application that create the object
    */
    public String getIcon() {
        return (String) base.opt("icon");
    }

    /** The id of the application that created the object
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The name of the application that created the object
    */
    public String getName() {
        return (String) base.opt("name");
    }

    /** The link to the photo of the application that created the object
    */
    public String getPhoto() {
        return (String) base.opt("photo");
    }

    /** The url for the application that created the object
    */
    public String getUrl() {
        return (String) base.opt("url");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}