package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  Contains specials offered by a venue

*/
public class FoursquareSpecial {
    protected JSONObject base;
    
    public FoursquareSpecial(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** 
    */
    public String getDescription() {
        return (String) base.opt("description");
    }

    /** 
    */
    public String getFinePrint() {
        return (String) base.opt("finePrint");
    }

    /** 
    */
    public String getIcon() {
        return (String) base.opt("icon");
    }

    /** 
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** 
    */
    public String getMessage() {
        return (String) base.opt("message");
    }

    /** 
    */
    public String getProvider() {
        return (String) base.opt("provider");
    }

    /** 
    */
    public String getRedemption() {
        return (String) base.opt("redemption");
    }

    /** 
    */
    public String getTitle() {
        return (String) base.opt("title");
    }

    /** 
    */
    public String getType() {
        return (String) base.opt("type");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}