package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import com.temboo.outputs.Foursquare.FoursquareLikes;
import com.temboo.outputs.Foursquare.FoursquareVenue;

/**  Contains a list of specials
  
*/
public class FoursquareSpecialsList {
    protected JSONObject base;
    
    public FoursquareSpecialsList(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The special description
    */
    public String getDescription() {
        return (String) base.opt("description");
    }

    /** The fine print of the special
    */
    public String getFinePrint() {
        return (String) base.opt("finePrint");
    }

    /** The icon name
    */
    public String getIcon() {
        return (String) base.opt("icon");
    }

    /** The special id
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** Get the likes for the special
    */
    public FoursquareLikes getLikes() {
        return new FoursquareLikes(base.opt("likes"));
    }

    /** The message text for this special
    */
    public String getMessage() {
        return (String) base.opt("message");
    }

    /** The provider of the special
    */
    public String getProvider() {
        return (String) base.opt("provider");
    }

    /** The redemption type
    */
    public String getRedemption() {
        return (String) base.opt("redemption");
    }

    /** The title of the special
    */
    public String getTitle() {
        return (String) base.opt("title");
    }

    /** The special type
    */
    public String getType() {
        return (String) base.opt("type");
    }

    /** Get the venue offering the special
    */
    public FoursquareVenue getVenue() {
        return new FoursquareVenue(base.opt("venue"));
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}