package com.temboo.outputs.Foursquare;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  Contains categories of todos associated with the venue
    
*/
public class FoursquareTodoCategory {
    protected JSONObject base;
    
    public FoursquareTodoCategory(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The icon for the todo category
    */
    public String getIcon() {
        return (String) base.opt("icon");
    }

    /** The id of the todo category
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** The name of the todo category
    */
    public String getName() {
        return (String) base.opt("name");
    }

    /** The plural name of the todo category
    */
    public String getPluralName() {
        return (String) base.opt("pluralName");
    }

    /** The short name of the todo category
    */
    public String getShortName() {
        return (String) base.opt("shortName");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}