package com.temboo.outputs.Google.Drive;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;

/**  An object containing a parent resource

*/
public class GoogleParent {
    protected JSONObject base;
    
    public GoogleParent(Object base) {
    	if (base instanceof JSONObject) {
            this.base = (JSONObject) base;
        } else if (base instanceof JSONArray) {
            if (((JSONArray)base).length()==0) {
                this.base=new JSONObject();
            } else {
                throw new ClassCastException("Expecting JSONObject but got non-empty JSONArray");
            }
        }
    }

    /** The id of the folder
    */
    public String getId() {
        return (String) base.opt("id");
    }

    /** Whether or not this folder is the root
    */
    public Boolean getIsRoot() {
        return (Boolean) base.opt("isRoot");
    }

    /** The type of resource
    */
    public String getKind() {
        return (String) base.opt("kind");
    }

    /** The link to the parent
    */
    public String getParentLink() {
        return (String) base.opt("parentLink");
    }

    /** A link back to this reference
    */
    public String getSelfLink() {
        return (String) base.opt("selfLink");
    }
    
    /* Internal utility method; retrieve the base JSON object for this element of the response data.
    */
    public JSONObject getBase() {
        return base;
    }
	/* Internal utility method; retrieve a sub-object from a JSON object/array; returns an empty object if key is not present
	*/
	protected JSONObject getJSONObject(Object json, String key) {
		JSONObject toReturn = null;

		try {
			if(json != null && (json instanceof JSONObject))
				toReturn = ((JSONObject) json).optJSONObject(key);					
		} catch(Exception e) {
		}
		if(toReturn == null)
			toReturn = new JSONObject();
		
		return toReturn;
	}
}